package lecture3

import org.scalameter.*

import java.util.*
import java.util.concurrent.ConcurrentSkipListSet
import scala.collection.*
import scala.collection.parallel.CollectionConverters.IterableIsParallelizable

// TODO : THIS DOES NOT COMPILE
def intersection_correct(a: GenSet[Int], b: GenSet[Int]) =
  val result = new ConcurrentSkipListSet[Int]()
  for (x <- a) if (b contains x) result add x
  result

@main def intersectionCorrect =
  val seqres = intersection_correct((0 until 1000).toSet, (0 until 1000 by 4).toSet)
  val parres = intersection_correct((0 until 1000).par.toSet, (0 until 1000 by 4).par.toSet)
  log(s"Sequential result - ${seqres.size}")
  log(s"Parallel result - ${parres.size}")


